package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.TxID;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
// UnionType: TransactionType
// UnionValue: SyntheticDepositCredits

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SyntheticDepositCredits")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SyntheticDepositCredits implements TransactionBody {
	public final TransactionType type = TransactionType.SYNTHETIC_DEPOSIT_CREDITS;
	private TxID cause;
	private Url source;
	private Url initiator;
	private long feeRefund;
	private long amount;
	private java.math.BigInteger acmeRefundAmount;
	private boolean isRefund;

    //
	public TxID getCause() {
	    return cause;
	}
	public void setCause(final TxID value) {
	    this.cause = value;
	}

	public SyntheticDepositCredits cause(final TxID value) {
	    setCause(value);
	    return this;
	}
	public Url getSource() {
	    return source;
	}
	public void setSource(final Url value) {
	    this.source = value;
	}

	public SyntheticDepositCredits source(final Url value) {
	    setSource(value);
	    return this;
	}
	public SyntheticDepositCredits source(final String value) {
	    setSource(Url.toAccURL(value));
	    return this;
	}
	public Url getInitiator() {
	    return initiator;
	}
	public void setInitiator(final Url value) {
	    this.initiator = value;
	}

	public SyntheticDepositCredits initiator(final Url value) {
	    setInitiator(value);
	    return this;
	}
	public SyntheticDepositCredits initiator(final String value) {
	    setInitiator(Url.toAccURL(value));
	    return this;
	}
	public long getFeeRefund() {
	    return feeRefund;
	}
	public void setFeeRefund(final long value) {
	    this.feeRefund = value;
	}

	public SyntheticDepositCredits feeRefund(final long value) {
	    setFeeRefund(value);
	    return this;
	}
	public long getAmount() {
	    return amount;
	}
	public void setAmount(final long value) {
	    this.amount = value;
	}

	public SyntheticDepositCredits amount(final long value) {
	    setAmount(value);
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getAcmeRefundAmount() {
	    return acmeRefundAmount;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setAcmeRefundAmount(final java.math.BigInteger value) {
	    this.acmeRefundAmount = value;
	}

	public SyntheticDepositCredits acmeRefundAmount(final java.math.BigInteger value) {
	    setAcmeRefundAmount(value);
	    return this;
	}
	public boolean getIsRefund() {
	    return isRefund;
	}
	public void setIsRefund(final boolean value) {
	    this.isRefund = value;
	}

	public SyntheticDepositCredits isRefund(final boolean value) {
	    setIsRefund(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.cause == null)) {
            marshaller.writeTxid(2, this.cause);
        }
        if (!(this.source == null)) {
            marshaller.writeUrl(3, this.source);
        }
        if (!(this.initiator == null)) {
            marshaller.writeUrl(4, this.initiator);
        }
        if (!(this.feeRefund == 0)) {
            marshaller.writeUint(5, this.feeRefund);
        }
        if (!(this.amount == 0)) {
            marshaller.writeUint(6, this.amount);
        }
        if (!((this.acmeRefundAmount).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(7, this.acmeRefundAmount);
        }
        if (!(!this.isRefund)) {
            marshaller.writeBool(8, this.isRefund);
        }
        return marshaller.array();
    }
}
